using System;
using System.IO;
using System.Collections;
using System.Xml;
using System.Xml.Serialization;
using NUnit.Framework;

namespace PSP
{
	/// <summary>
	/// ۑF01A_CS
	///     ςƕW΍o
	/// 쐬Ftsutomu
	/// PSPStudy o[WF1.03
	/// </summary>
	[TestFixture]
	public class C01A_CS
	{
		/// <summary>
		/// 0̏ꍇASeXgsAʂ result.txt ɏo͂܂B
		/// 1ȏ̏ꍇAt@Cf[^ǂŌʂWo͂ɏo͂܂B
		/// </summary>
		[STAThread]
		static void Main(string[] args)
		{
			if (args.Length == 0)	// Sf[^ŃeXg
			{
				Directory.SetCurrentDirectory("../..");
				CAllTest.Check("tsutomu","01A_CS",new Delegate(Main),false);
				return;
			}
			LinkList	l;
			if (!ReadData(args[0],out l)) return;
			double		ave,std;
			Calc(l,out ave,out std);
			Console.WriteLine("{0:F2} {1:F5}",ave,std);
		}
		/// <summary>
		/// t@Cf[^Ǎ݂܂B
		/// </summary>
		public static bool ReadData(string fnam,out LinkList l)
		{
			// t@CJ
			try 
			{
				XmlSerializer xr = new XmlSerializer(typeof(LinkList));
				StreamReader sr = new StreamReader(fnam);
				l = (LinkList)xr.Deserialize(sr);
				sr.Close();
			}
			catch (FileNotFoundException e) 
			{
				Console.Error.WriteLine(e.Message);
				l = null;
				return false;
			}
			return true;
		}
		/// <summary>
		/// ςƕW΍vZ܂B
		/// </summary>
		public static void Calc(LinkList l,out double ave,out double std)
		{
			ave = std = 0;
			foreach (double d in l) 
			{
				ave += d;
				std += d*d;
			}
			ave /= Math.Max(1,l.Count);
			std = Math.Sqrt((std - ave * ave * l.Count) / Math.Max(1,l.Count-1));
		}
		[Test]
		public void TestCalc()
		{
			LinkList	l = new LinkList();
			double		ave,std;
			Calc(l,out ave,out std);
			Assertion.AssertEquals("vf1̕",ave,0.0,0.0);
			Assertion.AssertEquals("vf1̕W΍",std,0.0,0.0);
			l.Add(123.4);
			Calc(l,out ave,out std);
			Assertion.AssertEquals("vf2̕",ave,123.4,0.0);
			Assertion.AssertEquals("vf2̕W΍",std,0.0,0.0);
			l.Add(125.4);
			l.Add(136.4);
			Calc(l,out ave,out std);
			Assertion.AssertEquals("vf3̕",ave,128.4,0.0);
			Assertion.AssertEquals("vf3̕W΍",std,7.0,0.0);
		}
	}
	/// <summary>
	/// NXg
	/// </summary>
	[TestFixture]
	public class LinkList : IEnumerable
	{
		private class Enumrt : IEnumerator 
		{
			private Data		cur;
			private Data		top;
			public Enumrt(Data d) {top = d; Reset();}
			public void Reset() {cur = top;}
			public object Current 
			{
				get {return cur.dat;}
			}
			public bool MoveNext()				
			{
				if (cur.next == null) return false;
				cur = cur.next;
				return true;
			}
		}
		private class Data 
		{
			public object	dat;
			public Data		next;
			public Data(object o) {dat = o; next = null;}
		}
		private int			n;
		private Data		dt;
		public LinkList()
		{
			n = 0;
			dt = new Data(null);
		}
		public int Count 
		{
			get {return n;}
		}
		public void Add(object o) 
		{
			Data	p = dt;
			while (p.next != null) p = p.next;
			p.next = new Data(o);
			++n;
		}
		public IEnumerator GetEnumerator()
		{
			return new Enumrt(dt);
		}
		[Test]
		public void Test()
		{
			LinkList l = new LinkList();
			object[] a = {1,"abc"};
			foreach (object o in a) l.Add(o);
			int i = 0;
			foreach (object o in l)
				Assertion.AssertEquals("vf̊mF",o,a[i++]);
		}
	}
}
