using System;
using System.IO;
using System.Collections;
using NUnit.Framework;

namespace PSP
{
	/// <summary>
	/// ۑF03A_CS
	///     NXʂ ֐̐LOCóB
	/// 쐬Ftsutomu
	/// PSPStudy o[WF1.03
	/// </summary>
	[TestFixture]
	public class C03A_CS
	{
		/// <summary>
		/// 0̏ꍇASeXgsAʂ result.txt ɏo͂܂B
		/// 1ȏ̏ꍇAt@Cf[^ǂŌʂWo͂ɏo͂܂B
		/// </summary>
		[STAThread]
		static void Main(string[] args)
		{
			if (args.Length == 0)	// Sf[^ŃeXg
			{
				Directory.SetCurrentDirectory("../..");
				CAllTest.Check("tsutomu","03A_CS",new Delegate(Main),false);
				return;
			}
			SortedList	sl;
			CalcLoc(args[0],out sl);
			int		t1 = 0, t2 = 0;
			Console.WriteLine("{0,-16} {1,4} {2,4}","Namespace","Func","LOC");
			foreach (DictionaryEntry de in sl) 
			{
				int[] dt = (int[])de.Value;
				Console.WriteLine(" {0,-15} {1,4} {2,4}",de.Key.ToString(),dt[0],dt[1]);
				t1 += dt[0];
				t2 += dt[1];
			}
			Console.WriteLine("{0,-16} {1,4} {2,4}","Total",t1,t2);
		}
		/// <summary>
		/// t@CǂLOCo͂܂B
		/// </summary>
		public static void CalcLoc(string fnam,out SortedList sl)
		{
			sl = new SortedList();
			// t@CJ
			StreamReader sr;
			try 
			{
				sr = new StreamReader(fnam);
			}
			catch (FileNotFoundException e) 
			{
				Console.WriteLine(e.Message);
				return;
			}
			ArrayList	all = new ArrayList();
			int			c,cc;
			bool		bIn = false;
			while ((c = sr.Read()) >= 0) 
			{
				if (c == '\\') 
				{
					sr.Read();
				}
				else if (c == '\'' || c == '"') 
				{
					while ((cc = sr.Read()) >= 0)
						if (cc == '\\') sr.Read();
						else if (cc == c) break;
				} 
				else if (c == ';' || c == '{' || c == '}') 
				{
					all.Add(((char)c).ToString());
				}
				if (Char.IsLetter((char)c) || c == '_')
				{
					string	id = ((char)c).ToString();
					while ((c = sr.Peek()) == '_' || Char.IsLetterOrDigit((char)c)) 
					{
						sr.Read();
						id += (char)c;
					}
					if (bIn) 
					{
						all.Add(id);
						bIn = false;
					} 
					else bIn = id == "class" || id == "struct" || id == "namespace";
				}
				if (c != '/') continue;
				c = sr.Peek();
				if (c == '/') 
				{
					while ((c = sr.Read()) != '\n') ;
				} 
				else if (c == '*') 
				{
					do 
					{
					while ((c = sr.Read()) >= 0)
						if (c == '*') break;
					} while (c >= 0 && sr.Peek() != '/');
					sr.Read();
				}
			}
			sr.Close();
			int			level = 0;
			string		ns = "";
			bool		bInClass = false;
			foreach (string s in all) 
			{
				if (s == "}") 
				{
					if (level > 0) 
					{
						--level; 
					} 
					else 
					{
						int	k = ns.LastIndexOf('.');
						ns = k < 0 ? "" : ns.Substring(0,k);
					}
					continue;
				} 
				int[] v = (int[])sl[ns];
				if (v == null) 
				{
					v = new int[2];
					if (ns != "") sl[ns] = v;
				}
				if (s == ";") 
				{
					++v[1];
				} 
				else if (s == "{") 
				{
					++v[1];
					if (bInClass) 
					{
						bInClass = false;
					}
					else
					{
						if (++level == 1) ++v[0];
					}
				}			
				else				
				{
					bInClass = true;
					if (ns != "") ns += ".";
					ns += s;
				}
			}
		}
		[Test]
		public void TestCalcLoc()
		{
			string fnam = "testCase.txt";
			StreamWriter sw;
			sw = new StreamWriter(fnam);
			sw.WriteLine("namespace Test");
			sw.WriteLine("{");
			sw.WriteLine("	// test;");
			sw.WriteLine("	public class CTest : Object");
			sw.WriteLine("	{");
			sw.WriteLine("		private struct A");
			sw.WriteLine("		{");
			sw.WriteLine("			struct B {void h(){}}");
			sw.WriteLine("			public void f() {int i = 0; {Console.Write(0);}}");
			sw.WriteLine("		}");
			sw.WriteLine("		private int	member; /* ; */");
			sw.WriteLine("		public CTest() {;}");
			sw.WriteLine("		[STAThread]");
			sw.WriteLine("		static void Main(string[] args)");
			sw.WriteLine("		{");
			sw.WriteLine("			Console.WriteLine(\"test;\");");
			sw.WriteLine("		}");
			sw.WriteLine("	}");
			sw.WriteLine("}");
			sw.WriteLine("");
			sw.WriteLine("class C");
			sw.WriteLine("{");
			sw.WriteLine("	public virtual double i()");
			sw.WriteLine("	{");
			sw.WriteLine("		return 0;");
			sw.WriteLine("	}");
			sw.WriteLine("}");
			sw.Close();
			object[,] ans = {{"C",1,3},{"Test",0,1},{"Test.CTest",2,6},
				{"Test.CTest.A",1,5},{"Test.CTest.A.B",1,2}};
			SortedList	sl;
			CalcLoc(fnam,out sl);
			int		i = 0, n = ans.GetLength(0);
			Assertion.AssertEquals("ʃTCY",sl.Count,n);
			foreach (DictionaryEntry de in sl)
			{
				int[] dt = (int[])de.Value;
				Assertion.AssertEquals("ƍ1",de.Key,ans[i,0]);
				Assertion.AssertEquals("ƍ2",dt[0],ans[i,1]);
				Assertion.AssertEquals("ƍ3",dt[1],ans[i,2]);
				++i;
			}
			File.Delete(fnam);
		}
	}
}
