Imports System.IO
Imports System.Xml
Imports System.Xml.Serialization
Imports NUnit.Framework

Namespace PSP
    ''' ۑF03A_VB
    '''     OƂ̊֐̐LOC̃JEg
    ''' 쐬Ftsutomu
    ''' PSPStudy o[WF1.03
    <TestFixture()> _
    Public Class C03A_VB
        Shared Sub Main(ByVal args() As String)
            If (args.Length = 0) Then ' Sf[^ŃeXg
                Directory.SetCurrentDirectory("..")
                AllTest.Check("tsutomu", "03A_VB", AddressOf Main, False)
                Exit Sub
            End If
            Dim sl As SortedList
            CalcLoc(args(0), sl)
            Dim t1, t2 As Integer, de As DictionaryEntry
            Console.WriteLine("{0,-26} {1,8} {2,4}", "Namespace", "Sub&Func", "LOC")
            For Each de In sl
                Dim f As Integer = CType(de.Value, Integer)
                Dim l As Integer = f / 10000
                f -= l * 10000
                If (de.Key.ToString() <> "") Then
                    Console.WriteLine(" {0,-25} {1,8} {2,4}", de.Key.ToString(), f, l)
                    t1 += f
                    t2 += l
                End If
            Next
            Console.WriteLine("{0,-26} {1,8} {2,4}", "Total", t1, t2)
        End Sub
        Public Shared Sub CalcLoc(ByVal fnam As String, ByRef sl As SortedList)
            sl = New SortedList()
            Dim sr As StreamReader
            Try
                sr = New StreamReader(fnam)
            Catch e As FileNotFoundException
                Console.Error.WriteLine(e.Message)
                Return
            End Try
            Dim st As ArrayList = New ArrayList()
            Do
                Dim s As String = sr.ReadLine()
                If (s Is Nothing) Then Exit Do
                DelWord(s)
                If (s.Length > 0) Then
                    Dim w() As String = s.Split(New Char() {" "c}, 2)
                    If (CheckName(w(0))) Then
                        st.Add(w(1))
                    End If
                    Dim ss() As String = CType(st.ToArray(Type.GetType("System.String")), String())
                    Dim key As String = String.Join(".", ss)
                    If (key = "") Then key = "Global"
                    Dim t As Integer = 10000
                    If (w(0) = "Sub" OrElse w(0) = "Function") Then t += 1
                    sl(key) = CType(sl(key), Integer) + t
                    If (w(0) = "End" AndAlso st.Count > 0 AndAlso CheckName(w(1))) Then
                        st.RemoveAt(st.Count - 1)
                    End If
                End If
            Loop
            sr.Close()
        End Sub
        Public Shared Sub DelWord(ByRef s As String)
            s = s.Trim()
            If (s.Length = 0) Then Return
            If (s.Chars(0) = "'"c) Then
                s = ""
                Return
            End If
            If (s.Chars(0) = "<"c) Then
                s = s.Substring(Math.Max(1, s.IndexOf(">"c) + 1))
                s = s.Trim()
            End If

            Dim ss() As String = {"Public", "Private", "Protected", "Friend", " Shadows", _
                "MustInherit", "NotInheritable", "Overloads", "Overrides", "Overridable", _
                "NotOverridable", "MustOverride", "Shared"}
            Dim t As String
            For Each t In ss
                s = s.Replace(t, "")
                s = s.Trim()
            Next
        End Sub
        Public Shared Function CheckName(ByVal s As String) As Boolean
            Return s = "Class" OrElse s = "Structure" OrElse s = "Module" OrElse s = "Namespace"
        End Function
        <Test()> _
        Public Sub TestCalcLoc()
            Dim fnam As String = "testCase.txt"
            Dim sw As StreamWriter
            sw = new StreamWriter(fnam)
            sw.WriteLine("Imports System.IO")
            sw.WriteLine("")
            sw.WriteLine("Namespace Namespace1")
            sw.WriteLine("    Public Module Module1")
            sw.WriteLine("        '")
            sw.WriteLine("        ' Hello world !")
            sw.WriteLine("        '")
            sw.WriteLine("        Sub Main()")
            sw.WriteLine("            Console.WriteLine(0)")
            sw.WriteLine("        End Sub")
            sw.WriteLine("    End Module")
            sw.WriteLine("End Namespace")
            sw.WriteLine("")
            sw.WriteLine("Module Module2")
            sw.WriteLine("    <System.Serializable()> NotInheritable Class Class1")
            sw.WriteLine("        Class Class2")
            sw.WriteLine("            Protected Friend Overridable Function Test()")
            sw.WriteLine("                Dim i As Integer")
            sw.WriteLine("            End Function")
            sw.WriteLine("        End Class")
            sw.WriteLine("        Structure Structure1")
            sw.WriteLine("            Private i As Integer")
            sw.WriteLine("        End Structure")
            sw.WriteLine("        Private Shared Sub Test()")
            sw.WriteLine("            Dim i As Integer")
            sw.WriteLine("        End Sub")
            sw.WriteLine("    End Class")
            sw.WriteLine("End Module")
            sw.Close()
            Dim ans(,) As Object = {{"Global", 0, 1}, {"Module2", 0, 2}, _
                {"Module2.Class1", 1, 5}, {"Module2.Class1.Class2", 1, 5}, _
                {"Module2.Class1.Structure1", 0, 3}, {"Namespace1", 0, 2}, _
                {"Namespace1.Module1", 1, 5}}
            Dim sl As SortedList
            CalcLoc(fnam, sl)
            Dim i, n As Integer, de As DictionaryEntry
            n = ans.GetLength(0)
            Assertion.AssertEquals("ʃTCY", sl.Count, n)
            For Each de In sl
                Dim f As Integer = CType(de.Value, Integer)
                Dim l As Integer = f / 10000
                f -= l * 10000
                Assertion.AssertEquals("ƍ1", de.Key,ans(i, 0))
                Assertion.AssertEquals("ƍ2", f, ans(i, 1))
                Assertion.AssertEquals("ƍ3", l, ans(i, 2))
                i += 1
            Next
            File.Delete(fnam)
        End Sub
    End Class
End Namespace
