using System;
using System.IO;
using System.Collections;
using System.Xml;
using System.Xml.Serialization;
using NUnit.Framework;

namespace PSP
{
	/// <summary>
	/// ۑF04A_CS
	///     `ǍW0A1߂B
	/// 쐬Ftsutomu
	/// PSPStudy o[WF1.03
	/// </summary>
	[TestFixture]
	public class C04A_CS
	{
		/// <summary>
		/// 0̏ꍇASeXgsAʂ result.txt ɏo͂܂B
		/// 1ȏ̏ꍇAt@Cf[^ǂŌʂWo͂ɏo͂܂B
		/// </summary>
		[STAThread]
		static void Main(string[] args)
		{
			if (args.Length == 0)	// Sf[^ŃeXg
			{
				Directory.SetCurrentDirectory("../..");
				CAllTest.Check("tsutomu","04A_CS",new Delegate(Main),false);
				return;
			}
			LinkList	l;
			if (!ReadData(args[0],out l)) return;
			double		sumx,sumy,b0,b1;
			Calc(l,out sumx,out sumy,out b0,out b1);
			Console.WriteLine("{0:F5} {1:F5}",b0,b1);
		}
		/// <summary>
		/// t@Cf[^Ǎ݂܂B
		/// </summary>
		public static bool ReadData(string fnam,out LinkList l)
		{
			// t@CJ
			try 
			{
				XmlSerializer xr = new XmlSerializer(typeof(LinkList),new Type[]{typeof(double[])});
				StreamReader sr = new StreamReader(fnam);
				l = (LinkList)xr.Deserialize(sr);
				sr.Close();
			}
			catch (FileNotFoundException e) 
			{
				Console.Error.WriteLine(e.Message);
				l = null;
				return false;
			}
			return true;
		}
		/// <summary>
		/// 0A1vZ܂B
		/// </summary>
		public static void Calc(LinkList l,out double sumx,out double sumy,out double b0,out double b1)
		{
			double	sumxx,sumxy;
			sumx = sumy = sumxx = sumxy = 0;
			foreach (double[] d in l) 
			{
				sumx += d[0];
				sumy += d[1];
				sumxx += d[0]*d[0];
				sumxy += d[0]*d[1];
			}
			if (l.Count > 0) sumx /= l.Count;
			if (l.Count > 0) sumy /= l.Count;
			b1 = sumxx - l.Count * sumx * sumx;
			if (b1 != 0) b1 = (sumxy - l.Count * sumx * sumy) / b1;
			b0 = sumy - b1 * sumx;
		}
		[Test]
		public void TestCalcLoc()
		{
			LinkList	l = new LinkList();
			double		sumx,sumy,b0,b1;
			Calc(l,out sumx,out sumy,out b0,out b1);
			Assertion.AssertEquals("vf̊mF",sumx,0);
			Assertion.AssertEquals("vf̊mF",sumy,0);
			Assertion.AssertEquals("vf̊mF",b0,0);
			Assertion.AssertEquals("vf̊mF",b1,0);
			l.Add(new double[]{1,123.4});
			Calc(l,out sumx,out sumy,out b0,out b1);
			Assertion.AssertEquals("vf̊mF",b0,123.4);
			Assertion.AssertEquals("vf̊mF",b1,0);
			l.Add(new double[]{2,223.4});
			Calc(l,out sumx,out sumy,out b0,out b1);
			Assertion.AssertEquals("vf̊mF",b0,23.4);
			Assertion.AssertEquals("vf̊mF",b1,100);
		}
	}
	/// <summary>
	/// NXg
	/// </summary>
	[TestFixture]
	public class LinkList : IEnumerable
	{
		private class Enumrt : IEnumerator 
		{
			private Data		cur;
			private Data		top;
			public Enumrt(Data d) {top = d; Reset();}
			public void Reset() {cur = top;}
			public object Current 
			{
				get {return cur.dat;}
			}
			public bool MoveNext()				
			{
				if (cur.next == null) return false;
				cur = cur.next;
				return true;
			}
		}
		private class Data 
		{
			public object	dat;
			public Data		next;
			public Data(object o) {dat = o; next = null;}
		}
		private int			n;
		private Data		dt;
		public LinkList()
		{
			n = 0;
			dt = new Data(null);
		}
		public int Count 
		{
			get {return n;}
		}
		public void Add(object o) 
		{
			Data	p = dt;
			while (p.next != null) p = p.next;
			p.next = new Data(o);
			++n;
		}
		public IEnumerator GetEnumerator()
		{
			return new Enumrt(dt);
		}
		[Test]
		public void Test()
		{
			LinkList l = new LinkList();
			object[] a = {1,"abc"};
			foreach (object o in a) l.Add(o);
			int i = 0;
			foreach (object o in l)
				Assertion.AssertEquals("vf̊mF",o,a[i++]);
		}
	}
}
