using System;
using System.IO;
using System.Collections;
using System.Xml;
using System.Xml.Serialization;
using NUnit.Framework;

namespace PSP
{
	public class Data 
	{
		public int			EstimateLOC;
		[XmlArrayAttribute("ArrayOfArrayOfDouble")]
		public double[][]	list;
	}
	/// <summary>
	/// ۑF06A_CS
	///     90%70%̗\sB
	/// 쐬Ftsutomu
	/// PSPStudy o[WF1.03
	/// </summary>
	[TestFixture]
	public class C06A_CS
	{
		/// <summary>
		/// 0̏ꍇASeXgsAʂ result.txt ɏo͂܂B
		/// 1ȏ̏ꍇAt@Cf[^ǂŌʂWo͂ɏo͂܂B
		/// </summary>
		[STAThread]
		static void Main(string[] args)
		{
			if (args.Length == 0)	// Sf[^ŃeXg
			{
				Directory.SetCurrentDirectory("../..");
				CAllTest.Check("tsutomu","06A_CS",new Delegate(Main),false);
				return;
			}
			LinkList	l = new LinkList();
			double		loc,sumx,sumy,b0,b1;
			if (!ReadData(args[0],l,out loc)) return;
			if (l.Count <= 2) return;
			C04A_CS.Calc(l,out sumx,out sumy,out b0,out b1);
			double	d,e, d1 = 0, d2 = 0;
			foreach (double[] dd in l)
			{
				d = dd[1] - b0 - b1*dd[0];
				d1 += d*d;
				d = dd[0] - sumx;
				d2 += d*d;
			}
			d = loc-sumx;
			d = Math.Sqrt((d1 / (l.Count-2.0)) * (1 + 1.0/l.Count + d*d / (d2>0 ? d2 : 1)));
			e = b0 + b1 * loc;
			Console.WriteLine("0 {0:F2}\n1 {1:F4}\nEst {2:F3}",b0,b1,e);
			double[]	rr = {0.7, 0.9};
			foreach (double r in rr) 
			{
				double g = d * CalcRevT(0.5+r/2, l.Count-2);
				Console.WriteLine("{0}% {1:F2} ` {2:F2}",(int)(r*100+.5),e-g,e+g);
			}
		}
		/// <summary>
		/// t@Cf[^Ǎ݂܂B
		/// </summary>
		public static bool ReadData(string fnam,LinkList l,out double loc)
		{
			loc = 0;
			// t@CJ
			try 
			{
				XmlSerializer xr = new XmlSerializer(typeof(Data));
				StreamReader sr = new StreamReader(fnam);
				Data data = (Data)xr.Deserialize(sr);
				sr.Close();
				foreach (double[] d in data.list) l.Add(d);
				loc = data.EstimateLOC;
			}
			catch (FileNotFoundException e) 
			{
				Console.Error.WriteLine(e.Message);
				return false;
			}
			return true;
		}
		public static double FuncT(double x,object o)
		{
			int	n = (int)o;
			return Math.Pow(1+x*x/n,-(n+1)/2.0);
		}
		public static double GFunc(double x,int n)
		{
			return 0.5 + Math.Exp(lngamma((n+1)/2.0) - lngamma(n/2.0)) / Math.Sqrt(n * Math.PI)
				* C05A_CS.Simpson(new CalcFunc(FuncT),0,x,n);
		}
		public static double CalcRevT(double x,int n)
		{
			double		v, m = 0, lo = 0, up = 3;
			int			cnt = 0;
			while (GFunc(up,n) < x) up *= 2;
			while (up - lo > 1e-8 && ++cnt < 64) 
			{
				m = (up+lo)/2;
				v = GFunc(m,n);
				if (v < x) lo = m;
				else up = m;
			}
			return m;
		}
		[Test]
		public void TestCalcRevT()
		{
			int		n = 8;
			double	d = .65;
			double	g = GFunc(d,n);
			Assertion.AssertEquals("t֐",CalcRevT(g,n),d,1e-8);
		}
		/// <summary>
		/// (x) = Math.Exp(lngamma(x))
		/// </summary>
		public static double lngamma(double xx)
		{
			double[]	cof = {
								  76.18009173,-86.50532033,24.01409822,
								  -1.231739516,0.120858003e-2,-0.536382e-5};
			double	x = xx-1.0;
			double	tmp = x+5.5;
			tmp -= (x+0.5)*Math.Log(tmp);
			double	ser = 1.0;
			for (int j=0;j<=5;j++) { x += 1.0; ser += cof[j]/x; }
			return -tmp+Math.Log(2.50662827465*ser);
		}
	}
}
