using System;
using System.IO;
using System.Collections;
using NUnit.Framework;

namespace PSP
{
	/// <summary>
	/// ۑF07A_CS
	///     ֌WƑւ̗LӐo͂܂B
	/// 쐬Ftsutomu
	/// PSPStudy o[WF1.03
	/// </summary>
	[TestFixture]
	public class C07A_CS
	{
		/// <summary>
		/// 0̏ꍇASeXgsAʂ result.txt ɏo͂܂B
		/// 1ȏ̏ꍇAt@Cf[^ǂŌʂWo͂ɏo͂܂B
		/// </summary>
		[STAThread]
		static void Main(string[] args)
		{
			if (args.Length == 0)	// Sf[^ŃeXg
			{
				Directory.SetCurrentDirectory("../..");
				CAllTest.Check("tsutomu","07A_CS",new Delegate(Main),false);
				return;
			}
			LinkList	l;
			double		r,t;
			if (!C04A_CS.ReadData(args[0],out l)) return;
			if (l.Count <= 2) return;
			Calc(l,out r,out t);
			double	p = GFunc(t,l.Count-2);
			Console.WriteLine("r = {0:F4}\nt = {1:F4}\n2(1-p) = {2:E2}",r,t,2*(1-p));
		}
		/// <summary>
		/// ֌WvZ܂B
		/// </summary>
		public static void Calc(LinkList l,out double r,out double t)
		{
			System.Diagnostics.Trace.Assert(l.Count > 2);
			double	sumx,sumy,sumxx,sumxy,sumyy;
			sumx = sumy = sumxx = sumxy = sumyy = 0;
			foreach (double[] d in l) 
			{
				sumx += d[0];
				sumy += d[1];
				sumxx += d[0]*d[0];
				sumxy += d[0]*d[1];
				sumyy += d[1]*d[1];
			}
			r = Math.Sqrt((l.Count*sumxx - sumx*sumx) * (l.Count*sumyy - sumy*sumy));
			r = (l.Count*sumxy - sumx*sumy) / (r != 0 ? r : 1);
			t = 1 - r*r;
			t = Math.Abs(r) * Math.Sqrt((l.Count-2) / (t != 0 ? t : 1));
		}
		[Test]
		public void TestCalc()
		{
			LinkList	l = new LinkList();
			double		r,t;
			l.Add(new double[]{1,2});
			l.Add(new double[]{2,1});
			l.Add(new double[]{3,3});
			Calc(l,out r,out t);
			Assertion.AssertEquals("֌Wr",r,0.5);
			Assertion.AssertEquals("֌Wt",t,Math.Sqrt(1/3.0));
		}
		public static double FuncT(double x,object o)
		{
			int	n = (int)o;
			return Math.Pow(1+x*x/n,-(n+1)/2.0);
		}
		public static double GFunc(double x,int n)
		{
			return 0.5 + Math.Exp(lngamma((n+1)/2.0) - lngamma(n/2.0)) / Math.Sqrt(n * Math.PI)
				* C05A_CS.Simpson(new CalcFunc(FuncT),0,x,n);
		}
		/// <summary>
		/// (x) = Math.Exp(lngamma(x))
		/// </summary>
		public static double lngamma(double xx)
		{
			double[]	cof = {
				76.18009173,-86.50532033,24.01409822,
				-1.231739516,0.120858003e-2,-0.536382e-5};
			double	x = xx-1.0;
			double	tmp = x+5.5;
			tmp -= (x+0.5)*Math.Log(tmp);
			double	ser = 1.0;
			for (int j=0;j<=5;j++) { x += 1.0; ser += cof[j]/x; }
			return -tmp+Math.Log(2.50662827465*ser);
		}
	}
}
