using System;
using System.IO;
using System.Collections;
using System.Xml;
using System.Xml.Serialization;
using NUnit.Framework;

namespace PSP
{
	public delegate bool Compare(object i,object j,object g);
	public class Data 
	{
		public int			ColumnOfCalc;
		[XmlArrayAttribute("ArrayOfArrayOfDouble")]
		public double[][]	list;
	}
	/// <summary>
	/// ۑF08A_CS
	///     \[gB
	/// 쐬Ftsutomu
	/// PSPStudy o[WF1.03
	/// </summary>
	[TestFixture]
	public class C08A_CS
	{
		/// <summary>
		/// 0̏ꍇASeXgsAʂ result.txt ɏo͂܂B
		/// 1ȏ̏ꍇAt@Cf[^ǂŌʂWo͂ɏo͂܂B
		/// </summary>
		[STAThread]
		static void Main(string[] args)
		{
			if (args.Length == 0)	// Sf[^ŃeXg
			{
				Directory.SetCurrentDirectory("../..");
				CAllTest.Check("tsutomu","08A_CS",new Delegate(Main),false);
				return;
			}
			LinkList	l = new LinkList();
			int			col;
			if (!ReadData(args[0],l,out col)) return;
			object[] a = new object[l.Count];
			int		i = 0;
			foreach (double[] d in l) a[i++] = d;
			Sort(a,new Compare(CompFunc),0,a.Length,col);
			foreach (double[] d in a) 
			{
				Console.WriteLine("{0} {1} {2}",d[0],d[1],d[2]);
			}
		}
		/// <summary>
		/// t@Cf[^Ǎ݂܂B
		/// </summary>
		public static bool ReadData(string fnam,LinkList l,out int col)
		{
			col = 0;
			// t@CJ
			try 
			{
				XmlSerializer xr = new XmlSerializer(typeof(Data));
				StreamReader sr = new StreamReader(fnam);
				Data data = (Data)xr.Deserialize(sr);
				sr.Close();
				foreach (double[] d in data.list) l.Add(d);
				col = data.ColumnOfCalc;
			}
			catch (FileNotFoundException e) 
			{
				Console.Error.WriteLine(e.Message);
				return false;
			}
			return true;
		}
		public static bool CompFunc(object i,object j,object g)
		{
			double[] d1 = (double[])i;
			double[] d2 = (double[])j;
			int		l = (int)g;
			return d1[l] <= d2[l];
		}
		/// <summary>
		/// }[W\[gB
		/// </summary>
		public static void Sort(object[] a,Compare f,int i,int j,object g)
		{
			if (j-i < 2)return;
			int		h, k = (i+j)/2, s = 0, t = k;
			Sort(a,f,i,k,g);
			Sort(a,f,k,j,g);
			object[] o = new object[k-i];
			for (h=0;h<k-i;++h) o[h] = a[i+h];
			for (h=i;h<j;++h) 
				a[h] = (s < k-i && (t == j || f(o[s],a[t],g))) ? o[s++] : a[t++];
		}
		[Test]
		public void TestSort()
		{
			object[] a = {new double[]{2,1,3}, new double[]{1,2,2}, new double[]{3,3,1}};
			for (int i=0;i<3;++i)
			{
				Sort(a,new Compare(CompFunc),0,a.Length,i);
				for (int j=0;j<3;++j)
					Assertion.AssertEquals("Sort",((double[])a[j])[i],j+1);
			}
		}
	}
	/// <summary>
	/// NXg
	/// </summary>
	[TestFixture]
	public class LinkList : IEnumerable
	{
		private class Enumrt : IEnumerator 
		{
			private Data		cur;
			private Data		top;
			public Enumrt(Data d) {top = d; Reset();}
			public void Reset() {cur = top;}
			public object Current 
			{
				get {return cur.dat;}
			}
			public bool MoveNext()				
			{
				if (cur.next == null) return false;
				cur = cur.next;
				return true;
			}
		}
		private class Data 
		{
			public object	dat;
			public Data		next;
			public Data(object o) {dat = o; next = null;}
		}
		private int			n;
		private Data		dt;
		public LinkList()
		{
			n = 0;
			dt = new Data(null);
		}
		public int Count 
		{
			get {return n;}
		}
		public void Add(object o) 
		{
			Data	p = dt;
			while (p.next != null) p = p.next;
			p.next = new Data(o);
			++n;
		}
		public IEnumerator GetEnumerator()
		{
			return new Enumrt(dt);
		}
		[Test]
		public void Test()
		{
			LinkList l = new LinkList();
			object[] a = {1,"abc"};
			foreach (object o in a) l.Add(o);
			int i = 0;
			foreach (object o in l)
				Assertion.AssertEquals("vf̊mF",o,a[i++]);
		}
	}
}
