using System;
using System.IO;
using System.Collections;
using NUnit.Framework;

namespace PSP
{
	/// <summary>
	/// ۑF09A_CS
	///     Kz̓x̌vZB
	/// 쐬Ftsutomu
	/// PSPStudy o[WF1.03
	/// </summary>
	[TestFixture]
	public class C09A_CS
	{
		/// <summary>
		/// 0̏ꍇASeXgsAʂ result.txt ɏo͂܂B
		/// 1ȏ̏ꍇAt@Cf[^ǂŌʂWo͂ɏo͂܂B
		/// </summary>
		[STAThread]
		static void Main(string[] args)
		{
			if (args.Length == 0)	// Sf[^ŃeXg
			{
				Directory.SetCurrentDirectory("../..");
				CAllTest.Check("tsutomu","09A_CS",new Delegate(Main),false);
				return;
			}
			LinkList	l = new LinkList();
			int			g;
			if (!C08A_CS.ReadData(args[0],l,out g)) return;
			if (l.Count < 50 || l.Count%10 != 0) return;
			object[] a = new object[l.Count];
			int		i = 0;
			foreach (double[] d in l) a[i++] = d;
			C08A_CS.Sort(a,new Compare(C08A_CS.CompFunc),0,a.Length,g);
			double	Q,p;
			CalcQ(a,g,out Q,out p);
			Console.WriteLine("Q = {0:F1}, 1-p = {1:E2}",Q,1-p);
		}
		static double Func(double x,object o) 
		{
			return Math.Pow(x,(int)o / 2.0 - 1) * Math.Exp(-x/2);
		}
		public static void CalcQ(object[] a,int g,out double Q,out double p)
		{
			System.Diagnostics.Trace.Assert(a.Length >= 50 && a.Length%10 == 0);
			int		i,j,k,nn, n = a.Length;
			double	ave,sdv;
			ave = sdv = 0;
			foreach (double[] d in a) ave += d[g];
			ave /= n;
			foreach (double[] d in a) sdv += (d[g]-ave)*(d[g]-ave);
			sdv = Math.Sqrt(sdv / (n-1));
			if (sdv == 0) sdv = 1;
			foreach (double[] d in a) d[g] = (d[g]-ave) / sdv;
			const int s = 10;
			nn = n / s;
			double[]	t = {-1.282,-0.842,-0.524,-0.253,0,0.253,0.524,0.842,1.282,1e300};
			Q = 0;
			j = 0;
			for (i=0;i<s;++i) 
			{
				k = 0;
				while (j < n && ((double[])a[j])[g] < t[i]) {++j; ++k;}
				Q += (double)(nn-k)*(nn-k) / nn;
			}
			p = 1 / Math.Pow(2,(s-1)/2.0) / Math.Exp(lngamma((s-1)/2.0))
				* C05A_CS.Simpson(new CalcFunc(Func),0,Q,s-1);
		}
		[Test]
		public void TestCalcQ()
		{
			object[]	dat = new object[50];
			for (int i=0;i<dat.Length;++i) dat[i] = new double[]{i};
			double	Q,p;
			CalcQ(dat,0,out Q,out p);
			Assertion.AssertEquals("Q",Q,3.2);
			Assertion.AssertEquals("p",p,0.044,0.001);
		}
		/// <summary>
		/// (x) = Math.Exp(lngamma(x))
		/// </summary>
		public static double lngamma(double xx)
		{
			double[]	cof = {
				76.18009173,-86.50532033,24.01409822,
				-1.231739516,0.120858003e-2,-0.536382e-5};
			double	x = xx-1.0;
			double	tmp = x+5.5;
			tmp -= (x+0.5)*Math.Log(tmp);
			double	ser = 1.0;
			for (int j=0;j<=5;j++) { x += 1.0; ser += cof[j]/x; }
			return -tmp+Math.Log(2.50662827465*ser);
		}
	}
}
